OCC.Core.Select3D module

Select3D module, see official documentation at https://www.opencascade.com/doc/occt-7.4.0/refman/html/package_select3d.html

class Select3D_BVHIndexBuffer(*args)

Bases: object

  • Empty constructor.
    param theAlloc

    type theAlloc

    NCollection_BaseAllocator

    rtype

    None

static DownCast(t)
HasPatches()
Return type

bool

Index()
  • Access index at specified position
    param theIndex

    type theIndex

    int

    rtype

    int

Init()
  • Allocates new empty index array
    param theNbElems

    type theNbElems

    int

    param theHasPatches

    type theHasPatches

    bool

    rtype

    bool

PatchSize()
  • Access index at specified position
    param theIndex

    type theIndex

    int

    rtype

    int

SetIndex()
  • Change index at specified position
    param theIndex

    type theIndex

    int

    param theValue

    type theValue

    int

    rtype

    None* Change index at specified position

    param theIndex

    type theIndex

    int

    param theValue

    type theValue

    int

    param thePatchSize

    type thePatchSize

    int

    rtype

    None

property thisown

The membership flag

class Select3D_EntitySequence(*args)

Bases: object

Append()
Assign()
ChangeFirst()
ChangeLast()
ChangeValue()
Clear()
Exchange()
First()
InsertAfter()
InsertBefore()
IsEmpty()
Last()
Length()
Lower()
Prepend()
Remove()
Reverse()
Set()
SetValue()
Size()
Split()
Upper()
Value()
begin()
cbegin()
cend()
static delNode()
end()
property thisown

The membership flag

class Select3D_EntitySequenceIter(*args)

Bases: object

ChangeValue()
More()
Next()
Value()
property thisown

The membership flag

class Select3D_IndexedMapOfEntity(*args)

Bases: object

Add()
Assign()
Clear()
Contains()
Exchange()
FindIndex()
FindKey()
ReSize()
RemoveFromIndex()
RemoveKey()
RemoveLast()
Set()
Size()
Substitute()
Swap()
cbegin()
cend()
property thisown

The membership flag

class Select3D_InteriorSensitivePointSet(*args)

Bases: object

  • Splits the given point set thePoints onto planar convex polygons
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_Array1OfPnt

    rtype

    None

BoundingBox()
  • Returns bounding box of the point set. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

Box()
  • Returns bounding box of planar convex polygon with index theIdx
    param theIdx

    type theIdx

    int

    rtype

    Select3D_BndBox3d

Center()
  • Returns geometry center of planar convex polygon with index theIdx in the vector along the given axis theAxis
    param theIdx

    type theIdx

    int

    param theAxis

    type theAxis

    int

    rtype

    float

CenterOfGeometry()
  • Returns center of the point set. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
GetPoints()
  • Initializes the given array theHArrayOfPnt by 3d coordinates of vertices of the whole point set
    param theHArrayOfPnt

    type theHArrayOfPnt

    TColgp_HArray1OfPnt

    rtype

    void

NbSubElements()
  • Returns the amount of points in set
    rtype

    int

Size()
  • Returns the length of vector of planar convex polygons
    rtype

    int

Swap()
  • Swaps items with indexes theIdx1 and theIdx2 in the vector
    param theIdx1

    type theIdx1

    int

    param theIdx2

    type theIdx2

    int

    rtype

    void

property thisown

The membership flag

class Select3D_Pnt

Bases: object

Set()
Parameters

thePnt

type thePnt

gp_Pnt

rtype

gp_Pnt

property thisown

The membership flag

property x
property y
property z
class Select3D_PointData(*args)

Bases: object

Parameters

theNbPoints

type theNbPoints

int

rtype

None

Pnt()
Parameters

theIndex

type theIndex

int

rtype

Select3D_Pnt

Pnt3d()
Parameters

theIndex

type theIndex

int

rtype

gp_Pnt

SetPnt()
Parameters

theIndex

type theIndex

int

param theValue

type theValue

Select3D_Pnt

rtype

None:param theIndex:

type theIndex

int

param theValue

type theValue

gp_Pnt

rtype

None

Size()
Return type

int

property thisown

The membership flag

class Select3D_SensitiveBox(*args)

Bases: object

  • Constructs a sensitive box object defined by the owner theOwnerId, and the box theBox.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theBox

    type theBox

    Bnd_Box

    rtype

    None* Constructs a sensitive box object defined by the owner theOwnerId, and the coordinates theXmin, theYMin, theZMin, theXMax, theYMax, theZMax. theXmin, theYMin and theZMin define the minimum point in the front lower left hand corner of the box, and theXMax, theYMax and theZMax define the maximum point in the back upper right hand corner of the box.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theXMin

    type theXMin

    float

    param theYMin

    type theYMin

    float

    param theZMin

    type theZMin

    float

    param theXMax

    type theXMax

    float

    param theYMax

    type theYMax

    float

    param theZMax

    type theZMax

    float

    rtype

    None

BoundingBox()
  • Returns coordinates of the box. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

CenterOfGeometry()
  • Returns center of the box. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

Matches()
  • Checks whether the box overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

NbSubElements()
  • Returns the amount of sub-entities in sensitive
    rtype

    int

property thisown

The membership flag

class Select3D_SensitiveCircle(*args)

Bases: OCC.Core.Select3D.Select3D_SensitivePoly

  • Constructs the sensitive circle object defined by the owner theOwnerId, the circle theCircle, the boolean theIsFilled and the number of points theNbPnts.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theCircle

    type theCircle

    Geom_Circle

    param theIsFilled

    default value is Standard_False

    type theIsFilled

    bool

    param theNbPnts

    default value is 12

    type theNbPnts

    int

    rtype

    None* Constructs the sensitive arc object defined by the owner theOwnerId, the circle theCircle, the parameters theU1 and theU2, the boolean theIsFilled and the number of points theNbPnts. theU1 and theU2 define the first and last points of the arc on theCircle.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theCircle

    type theCircle

    Geom_Circle

    param theU1

    type theU1

    float

    param theU2

    type theU2

    float

    param theIsFilled

    default value is Standard_False

    type theIsFilled

    bool

    param theNbPnts

    default value is 12

    type theNbPnts

    int

    rtype

    None* Constructs the sensitive circle object defined by the owner theOwnerId, the array of triangles thePnts3d, and the boolean theIsFilled. thePnts3d is an array of consecutive triangles on the circle. The triangle i+1 lies on the intersection of the tangents to the circle of i and i+2. Note, that the first point of thePnts3d must be equal to the last point of thePnts3d.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePnts3d

    type thePnts3d

    TColgp_HArray1OfPnt

    param theIsFilled

    default value is Standard_False

    type theIsFilled

    bool

    rtype

    None* Constructs the sensitive circle object defined by the owner theOwnerId, the array of points thePnts3d, and the boolean theIsFilled. If the length of thePnts3d is more then 1, the first point of thePnts3d must be equal to the last point of thePnts3d.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePnts3d

    type thePnts3d

    TColgp_Array1OfPnt

    param theIsFilled

    default value is Standard_False

    type theIsFilled

    bool

    rtype

    None

ArrayBounds()
Parameters

theLow

type theLow

int

param theUp

type theUp

int

rtype

None

BVH()
  • Builds BVH tree for a circle’s edge segments if needed
    rtype

    void

static DownCast(t)
GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

GetPoint3d()
Parameters

thePntIdx

type thePntIdx

int

rtype

gp_Pnt

Matches()
  • Checks whether the circle overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

property thisown

The membership flag

class Select3D_SensitiveCurve(*args)

Bases: OCC.Core.Select3D.Select3D_SensitivePoly

  • Constructs a sensitive curve object defined by the owner theOwnerId, the curve theCurve, and the maximum number of points on the curve: theNbPnts.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theCurve

    type theCurve

    Geom_Curve

    param theNbPnts

    default value is 17

    type theNbPnts

    int

    rtype

    None* Constructs a sensitive curve object defined by the owner theOwnerId and the set of points ThePoints.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_HArray1OfPnt

    rtype

    None* Creation of Sensitive Curve from Points. Warning : This Method should disappear in the next version…

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_Array1OfPnt

    rtype

    None

static DownCast(t)
GetConnected()
  • Returns the copy of this
    rtype

    opencascade::handle<Select3D_SensitiveEntity>

property thisown

The membership flag

class Select3D_SensitiveFace(*args)

Bases: object

  • Constructs a sensitive face object defined by the owner theOwnerId, the array of points thePoints, and the sensitivity type theType. The array of points is the outer polygon of the geometric face.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_Array1OfPnt

    param theType

    type theType

    Select3D_TypeOfSensitivity

    rtype

    None* Constructs a sensitive face object defined by the owner theOwnerId, the array of points thePoints, and the sensitivity type theType. The array of points is the outer polygon of the geometric face.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_HArray1OfPnt

    param theType

    type theType

    Select3D_TypeOfSensitivity

    rtype

    None

BVH()
  • Builds BVH tree for the face
    rtype

    void

BoundingBox()
  • Returns bounding box of the face. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

CenterOfGeometry()
  • Returns center of the face. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

GetPoints()
  • Initializes the given array theHArrayOfPnt by 3d coordinates of vertices of the face
    param theHArrayOfPnt

    type theHArrayOfPnt

    TColgp_HArray1OfPnt

    rtype

    None

Matches()
  • Checks whether the face overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

NbSubElements()
  • Returns the amount of sub-entities (points or planar convex polygons)
    rtype

    int

property thisown

The membership flag

class Select3D_SensitiveGroup(*args)

Bases: object

  • Constructs an empty sensitive group object. This is a set of sensitive 3D entities. The sensitive entities will be defined using the function Add to fill the entity owner OwnerId. If MatchAll is false, nothing can be added.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theIsMustMatchAll

    default value is Standard_True

    type theIsMustMatchAll

    bool

    rtype

    None* Constructs a sensitive group object defined by the list TheList and the entity owner OwnerId. If MatchAll is false, nothing is done.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theEntities

    type theEntities

    Select3D_EntitySequence

    param theIsMustMatchAll

    default value is Standard_True

    type theIsMustMatchAll

    bool

    rtype

    None

Add()
  • Adds the list of sensitive entities LL to the empty sensitive group object created at construction time.
    param theEntities

    type theEntities

    Select3D_EntitySequence

    rtype

    None* Adds the sensitive entity aSensitive to the non-empty sensitive group object created at construction time.

    param theSensitive

    type theSensitive

    Select3D_SensitiveEntity

    rtype

    None

BoundingBox()
  • Returns bounding box of the group. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

Box()
  • Returns bounding box of sensitive entity with index theIdx
    param theIdx

    type theIdx

    int

    rtype

    Select3D_BndBox3d

Center()
  • Returns geometry center of sensitive entity index theIdx in the vector along the given axis theAxis
    param theIdx

    type theIdx

    int

    param theAxis

    type theAxis

    int

    rtype

    float

CenterOfGeometry()
  • Returns center of entity set. If location transformation is set, it will be applied
    rtype

    gp_Pnt

Clear()
  • Removes all sensitive entities from the list used at the time of construction, or added using the function Add.
    rtype

    None

static DownCast(t)
Entities()
  • Gets group content
    rtype

    Select3D_IndexedMapOfEntity

GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

IsIn()
  • Returns true if the sensitive entity aSensitive is in the list used at the time of construction, or added using the function Add.
    param theSensitive

    type theSensitive

    Select3D_SensitiveEntity

    rtype

    bool

LastDetectedEntity()
  • Return last detected entity.
    rtype

    opencascade::handle<Select3D_SensitiveEntity>

LastDetectedEntityIndex()
  • Return index of last detected entity.
    rtype

    int

Matches()
  • Checks whether the group overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

MustMatchAll()
  • Returns true if all sensitive entities in the list used at the time of construction, or added using the function Add must be matched.
    rtype

    bool

NbSubElements()
  • Returns the amount of sub-entities
    rtype

    int

Remove()
Parameters

theSensitive

type theSensitive

Select3D_SensitiveEntity

rtype

None

Set()
  • Sets the owner for all entities in group
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    rtype

    None

SetCheckOverlapAll()
  • Returns True if all sensitive entities should be checked within rectangular/polygonal selection, False by default. Can be useful for sensitive entities holding detection results as class property.
    param theToCheckAll

    type theToCheckAll

    bool

    rtype

    None

SetMatchType()
  • Sets the requirement that all sensitive entities in the list used at the time of construction, or added using the function Add must be matched.
    param theIsMustMatchAll

    type theIsMustMatchAll

    bool

    rtype

    None

Size()
  • Returns the length of vector of sensitive entities
    rtype

    int

SubEntity()
  • Access entity by index [1, NbSubElements()].
    param theIndex

    type theIndex

    int

    rtype

    opencascade::handle<Select3D_SensitiveEntity>

Swap()
  • Swaps items with indexes theIdx1 and theIdx2 in the vector
    param theIdx1

    type theIdx1

    int

    param theIdx2

    type theIdx2

    int

    rtype

    void

ToCheckOverlapAll()
  • Returns True if all sensitive entities should be checked within rectangular/polygonal selection, False by default. Can be useful for sensitive entities holding detection results as class property.
    rtype

    bool

property thisown

The membership flag

class Select3D_SensitivePoint(*args)

Bases: object

  • Constructs a sensitive point object defined by the owner OwnerId and the point Point.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoint

    type thePoint

    gp_Pnt

    rtype

    None

BoundingBox()
  • Returns bounding box of the point. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

CenterOfGeometry()
  • Returns center of point. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

Matches()
  • Checks whether the point overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

NbSubElements()
  • Returns the amount of sub-entities in sensitive
    rtype

    int

Point()
  • Returns the point used at the time of construction.
    rtype

    gp_Pnt

property thisown

The membership flag

class Select3D_SensitivePoly(*args)

Bases: object

  • Constructs a sensitive face object defined by the owner OwnerId, the array of points ThePoints, and the sensitivity type Sensitivity. The array of points is the outer polygon of the geometric face.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_Array1OfPnt

    param theIsBVHEnabled

    type theIsBVHEnabled

    bool

    rtype

    None* Constructs a sensitive face object defined by the owner OwnerId, the array of points ThePoints, and the sensitivity type Sensitivity. The array of points is the outer polygon of the geometric face.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePoints

    type thePoints

    TColgp_HArray1OfPnt

    param theIsBVHEnabled

    type theIsBVHEnabled

    bool

    rtype

    None* Constructs the sensitive circle object defined by the owner OwnerId, the circle Circle, the Boolean FilledCircle and the number of points NbOfPoints.

    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theIsBVHEnabled

    type theIsBVHEnabled

    bool

    param theNbPnts

    default value is 6

    type theNbPnts

    int

    rtype

    None

BoundingBox()
  • Returns bounding box of a polygon. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

Box()
  • Returns bounding box of segment with index theIdx
    param theIdx

    type theIdx

    int

    rtype

    Select3D_BndBox3d

Center()
  • Returns geometry center of sensitive entity index theIdx in the vector along the given axis theAxis
    param theIdx

    type theIdx

    int

    param theAxis

    type theAxis

    int

    rtype

    float

CenterOfGeometry()
  • Returns center of the point set. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
NbSubElements()
  • Returns the amount of segments in poly
    rtype

    int

Points3D()
  • Returns the 3D points of the array used at construction time.
    param theHArrayOfPnt

    type theHArrayOfPnt

    TColgp_HArray1OfPnt

    rtype

    None

Size()
  • Returns the amount of segments of the poly
    rtype

    int

Swap()
  • Swaps items with indexes theIdx1 and theIdx2 in the vector
    param theIdx1

    type theIdx1

    int

    param theIdx2

    type theIdx2

    int

    rtype

    void

property thisown

The membership flag

class Select3D_SensitivePrimitiveArray(*args)

Bases: object

  • Constructs an empty sensitive object.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    rtype

    None

BVH()
  • Builds BVH tree for sensitive set.
    rtype

    void

BoundingBox()
  • Returns bounding box of the triangulation. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

Box()
  • Returns bounding box of triangle/edge with index theIdx
    param theIdx

    type theIdx

    int

    rtype

    Select3D_BndBox3d

Center()
  • Returns geometry center of triangle/edge with index theIdx in array along the given axis theAxis
    param theIdx

    type theIdx

    int

    param theAxis

    type theAxis

    int

    rtype

    float

CenterOfGeometry()
  • Returns center of triangulation. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

HasInitLocation()
  • Returns true if the shape corresponding to the entity has init location
    rtype

    bool

InitPoints()
  • Initialize the sensitive object from point set. The sub-set of points can be specified by arguments theIndexLower and theIndexUpper (these are for iterating theIndices, not to restrict the actual index values!). @param theVerts attributes array containing Graphic3d_TOA_POS with type Graphic3d_TOD_VEC3 or Graphic3d_TOD_VEC2 @param theIndices index array defining points @param theInitLoc location @param theIndexLower the theIndices range - first value (inclusive), starting from 0 @param theIndexUpper the theIndices range - last value (inclusive), upto theIndices->NbElements-1 @param theToEvalMinMax compute bounding box within initialization @param theNbGroups number of groups to split the vertex array into several parts
    param theVerts

    type theVerts

    Graphic3d_Buffer

    param theIndices

    type theIndices

    Graphic3d_IndexBuffer

    param theInitLoc

    type theInitLoc

    TopLoc_Location

    param theIndexLower

    type theIndexLower

    int

    param theIndexUpper

    type theIndexUpper

    int

    param theToEvalMinMax

    default value is true

    type theToEvalMinMax

    bool

    param theNbGroups

    default value is 1

    type theNbGroups

    int

    rtype

    bool* Initialize the sensitive object from point set. @param theVerts attributes array containing Graphic3d_TOA_POS with type Graphic3d_TOD_VEC3 or Graphic3d_TOD_VEC2 @param theIndices index array to define subset of points @param theInitLoc location @param theToEvalMinMax compute bounding box within initialization @param theNbGroups number of groups to split the vertex array into several parts

    param theVerts

    type theVerts

    Graphic3d_Buffer

    param theIndices

    type theIndices

    Graphic3d_IndexBuffer

    param theInitLoc

    type theInitLoc

    TopLoc_Location

    param theToEvalMinMax

    default value is true

    type theToEvalMinMax

    bool

    param theNbGroups

    default value is 1

    type theNbGroups

    int

    rtype

    bool* Initialize the sensitive object from point set. @param theVerts attributes array containing Graphic3d_TOA_POS with type Graphic3d_TOD_VEC3 or Graphic3d_TOD_VEC2 @param theInitLoc location @param theToEvalMinMax compute bounding box within initialization @param theNbGroups number of groups to split the vertex array into several parts

    param theVerts

    type theVerts

    Graphic3d_Buffer

    param theInitLoc

    type theInitLoc

    TopLoc_Location

    param theToEvalMinMax

    default value is true

    type theToEvalMinMax

    bool

    param theNbGroups

    default value is 1

    type theNbGroups

    int

    rtype

    bool

InitTriangulation()
  • Initialize the sensitive object from triangualtion. The sub-triangulation can be specified by arguments theIndexLower and theIndexUpper (these are for iterating theIndices, not to restrict the actual index values!). @param theVerts attributes array containing Graphic3d_TOA_POS with type Graphic3d_TOD_VEC3 or Graphic3d_TOD_VEC2 @param theIndices index array defining triangulation @param theInitLoc location @param theIndexLower the theIndices range - first value (inclusive), starting from 0 and multiple by 3 @param theIndexUpper the theIndices range - last value (inclusive), upto theIndices->NbElements-1 and multiple by 3 @param theToEvalMinMax compute bounding box within initialization @param theNbGroups number of groups to split the vertex array into several parts
    param theVerts

    type theVerts

    Graphic3d_Buffer

    param theIndices

    type theIndices

    Graphic3d_IndexBuffer

    param theInitLoc

    type theInitLoc

    TopLoc_Location

    param theIndexLower

    type theIndexLower

    int

    param theIndexUpper

    type theIndexUpper

    int

    param theToEvalMinMax

    default value is true

    type theToEvalMinMax

    bool

    param theNbGroups

    default value is 1

    type theNbGroups

    int

    rtype

    bool* Initialize the sensitive object from triangualtion. @param theVerts attributes array containing Graphic3d_TOA_POS with type Graphic3d_TOD_VEC3 or Graphic3d_TOD_VEC2 @param theIndices index array defining triangulation @param theInitLoc location @param theToEvalMinMax compute bounding box within initialization @param theNbGroups number of groups to split the vertex array into several parts

    param theVerts

    type theVerts

    Graphic3d_Buffer

    param theIndices

    type theIndices

    Graphic3d_IndexBuffer

    param theInitLoc

    type theInitLoc

    TopLoc_Location

    param theToEvalMinMax

    default value is true

    type theToEvalMinMax

    bool

    param theNbGroups

    default value is 1

    type theNbGroups

    int

    rtype

    bool

InvInitLocation()
  • Returns inversed location transformation matrix if the shape corresponding to this entity has init location set. Otherwise, returns identity matrix.
    rtype

    gp_GTrsf

LastDetectedEdgeNode1()
  • Return the first node of last topmost detected edge or -1 if undefined (axis picking).
    rtype

    int

LastDetectedEdgeNode2()
  • Return the second node of last topmost detected edge or -1 if undefined (axis picking).
    rtype

    int

LastDetectedElement()
  • Return last topmost detected element or -1 if undefined (axis picking).
    rtype

    int

LastDetectedElementMap()
  • Return the index map of last detected elements (rectangle selection).
    rtype

    opencascade::handle<TColStd_HPackedMapOfInteger>

LastDetectedNode()
  • Return last topmost detected node or -1 if undefined (axis picking).
    rtype

    int

LastDetectedNodeMap()
  • Return the index map of last detected nodes (rectangle selection).
    rtype

    opencascade::handle<TColStd_HPackedMapOfInteger>

Matches()
  • Checks whether the sensitive entity is overlapped by current selecting volume.
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

NbSubElements()
  • Returns the amount of nodes in triangulation
    rtype

    int

PatchDistance()
  • Maximum allowed distance between consequential elements in patch (ShortRealLast() by default). Has no effect on indexed triangulation.
    rtype

    float

PatchSizeMax()
  • Return patch size limit (1 by default).
    rtype

    int

Set()
  • Sets the owner for all entities in group
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    rtype

    void

SetDetectEdges()
  • Setup keeping of the index of last topmost detected edge (axis picking).
    param theToDetect

    type theToDetect

    bool

    rtype

    None

SetDetectElementMap()
  • Setup keeping of the index map of last detected elements (rectangle selection).
    param theToDetect

    type theToDetect

    bool

    rtype

    None

SetDetectElements()
  • Setup keeping of the index of last topmost detected element (axis picking).
    param theToDetect

    type theToDetect

    bool

    rtype

    None

SetDetectNodeMap()
  • Setup keeping of the index map of last detected nodes (rectangle selection).
    param theToDetect

    type theToDetect

    bool

    rtype

    None

SetDetectNodes()
  • Setup keeping of the index of last topmost detected node (for axis picking).
    param theToDetect

    type theToDetect

    bool

    rtype

    None

SetMinMax()
  • Assign new not transformed bounding box.
    param theMinX

    type theMinX

    double

    param theMinY

    type theMinY

    double

    param theMinZ

    type theMinZ

    double

    param theMaxX

    type theMaxX

    double

    param theMaxY

    type theMaxY

    double

    param theMaxZ

    type theMaxZ

    double

    rtype

    None

SetPatchDistance()
  • Assign patch distance limit. Should be set before initialization.
    param thePatchDistMax

    type thePatchDistMax

    float

    rtype

    None

SetPatchSizeMax()
  • Assign patch size limit. Should be set before initialization.
    param thePatchSizeMax

    type thePatchSizeMax

    int

    rtype

    None

Size()
  • Returns the length of array of triangles or edges
    rtype

    int

Swap()
  • Swaps items with indexes theIdx1 and theIdx2 in array
    param theIdx1

    type theIdx1

    int

    param theIdx2

    type theIdx2

    int

    rtype

    void

ToDetectEdges()
  • Return flag to keep index of last topmost detected edge, False by default.
    rtype

    bool

ToDetectElementMap()
  • Return flag to keep index map of last detected elements, False by default (rectangle selection).
    rtype

    bool

ToDetectElements()
  • Return flag to keep index of last topmost detected element, True by default.
    rtype

    bool

ToDetectNodeMap()
  • Return flag to keep index map of last detected nodes, False by default (rectangle selection).
    rtype

    bool

ToDetectNodes()
  • Return flag to keep index of last topmost detected node, False by default.
    rtype

    bool

property thisown

The membership flag

class Select3D_SensitiveSegment(*args)

Bases: object

  • Constructs the sensitive segment object defined by the owner theOwnerId, the points theFirstPnt, theLastPnt
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param theFirstPnt

    type theFirstPnt

    gp_Pnt

    param theLastPnt

    type theLastPnt

    gp_Pnt

    rtype

    None

BoundingBox()
  • Returns bounding box of the segment. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

CenterOfGeometry()
  • Returns center of the segment. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
EndPoint()
  • gives the 3D End Point of the Segment
    rtype

    gp_Pnt* changes the end point of the segment

    param thePnt

    type thePnt

    gp_Pnt

    rtype

    None

GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

Matches()
  • Checks whether the segment overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

NbSubElements()
  • Returns the amount of points
    rtype

    int

SetEndPoint()
  • changes the end point of the segment
    param thePnt

    type thePnt

    gp_Pnt

    rtype

    None

SetStartPoint()
  • changes the start Point of the Segment;
    param thePnt

    type thePnt

    gp_Pnt

    rtype

    None

StartPoint()
  • gives the 3D start Point of the Segment
    rtype

    gp_Pnt* changes the start Point of the Segment;

    param thePnt

    type thePnt

    gp_Pnt

    rtype

    None

property thisown

The membership flag

class Select3D_SensitiveTriangle(*args)

Bases: object

  • Constructs a sensitive triangle object defined by the owner theOwnerId, the points P1, P2, P3, and the type of sensitivity Sensitivity.
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    param thePnt0

    type thePnt0

    gp_Pnt

    param thePnt1

    type thePnt1

    gp_Pnt

    param thePnt2

    type thePnt2

    gp_Pnt

    param theType

    default value is Select3D_TOS_INTERIOR

    type theType

    Select3D_TypeOfSensitivity

    rtype

    None

BoundingBox()
  • Returns bounding box of the triangle. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

Center3D()
  • Returns the center point of the sensitive triangle created at construction time.
    rtype

    gp_Pnt

CenterOfGeometry()
Return type

gp_Pnt

static DownCast(t)
GetConnected()
  • Returns the copy of this
    rtype

    opencascade::handle<Select3D_SensitiveEntity>

Matches()
  • Checks whether the triangle overlaps current selecting volume
    param theMgr

    type theMgr

    SelectBasics_SelectingVolumeManager

    param thePickResult

    type thePickResult

    SelectBasics_PickResult

    rtype

    bool

NbSubElements()
  • Returns the amount of points
    rtype

    int

Points3D()
  • Returns the 3D points P1, P2, P3 used at the time of construction.
    param thePnt0

    type thePnt0

    gp_Pnt

    param thePnt1

    type thePnt1

    gp_Pnt

    param thePnt2

    type thePnt2

    gp_Pnt

    rtype

    None

property thisown

The membership flag

class Select3D_SensitiveWire(*args)

Bases: object

  • Constructs a sensitive wire object defined by the owner theOwnerId
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    rtype

    None

Add()
  • Adds the sensitive entity theSensitive to this framework.
    param theSensitive

    type theSensitive

    Select3D_SensitiveEntity

    rtype

    None

BoundingBox()
  • Returns bounding box of the wire. If location transformation is set, it will be applied
    rtype

    Select3D_BndBox3d

Box()
  • Returns bounding box of sensitive entity with index theIdx
    param theIdx

    type theIdx

    int

    rtype

    Select3D_BndBox3d

Center()
  • Returns geometry center of sensitive entity index theIdx in the vector along the given axis theAxis
    param theIdx

    type theIdx

    int

    param theAxis

    type theAxis

    int

    rtype

    float

CenterOfGeometry()
  • Returns center of the wire. If location transformation is set, it will be applied
    rtype

    gp_Pnt

static DownCast(t)
GetConnected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

GetEdges()
  • returns the sensitive edges stored in this wire
    rtype

    NCollection_Vector<opencascade::handle<Select3D_SensitiveEntity> >

GetLastDetected()
Return type

opencascade::handle<Select3D_SensitiveEntity>

NbSubElements()
  • Returns the amount of sub-entities
    rtype

    int

Set()
  • Sets the owner for all entities in wire
    param theOwnerId

    type theOwnerId

    SelectMgr_EntityOwner

    rtype

    void

Size()
  • Returns the length of vector of sensitive entities
    rtype

    int

Swap()
  • Swaps items with indexes theIdx1 and theIdx2 in the vector
    param theIdx1

    type theIdx1

    int

    param theIdx2

    type theIdx2

    int

    rtype

    void

property thisown

The membership flag

class Select3D_Vec3(*args)

Bases: object

ChangeData()
static Cross()
static DX()
static DY()
static DZ()
Dot()
GetData()
static GetLERP()
IsEqual()
static Length()
Modulus()
Multiplied()
Multiply()
Normalize()
Normalized()
SetValues()
SquareModulus()
b()
cwiseAbs()
cwiseMax()
cwiseMin()
g()
maxComp()
minComp()
r()
property thisown

The membership flag

x()
xy()
xyz()
xz()
xzy()
y()
yx()
yxz()
yz()
yzx()
z()
zx()
zxy()
zy()
zyx()
class Select3D_VectorOfHPoly(*args)

Bases: object

Append()
Appended()
Assign()
ChangeFirst()
ChangeLast()
ChangeValue()
First()
IsEmpty()
Last()
Length()
Lower()
Set()
SetValue()
Size()
Upper()
Value()
begin()
cbegin()
cend()
end()
property thisown

The membership flag

class SwigPyIterator(*args, **kwargs)

Bases: object

advance()
copy()
decr()
distance()
equal()
incr()
next()
previous()
property thisown

The membership flag

value()